> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# AddScenario

POST https://api.voximplant.com/platform_api/AddScenario

Adds a new scenario to the <a href="https://voximplant.com/docs/gettingstarted/basicconcepts/scenarios#shared-scenarios">Shared</a> folder, so the scenario is available in all the existing applications. Please use the POST method.

When adding a scenario to the Shared folder, the `application_id` and `application_name` parameters should not be provided.

Allowed roles: `Owner`, `Admin`, `Developer`.

**Example request:** Add a new scenario: var s='hello';

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/scenarios/add-scenario

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /AddScenario:
    post:
      operationId: add-scenario
      summary: AddScenario
      description: >-
        Adds a new scenario to the <a
        href="https://voximplant.com/docs/gettingstarted/basicconcepts/scenarios#shared-scenarios">Shared</a>
        folder, so the scenario is available in all the existing applications.
        Please use the POST method.


        When adding a scenario to the Shared folder, the `application_id` and
        `application_name` parameters should not be provided.


        Allowed roles: `Owner`, `Admin`, `Developer`.


        **Example request:** Add a new scenario: var s='hello';
      tags:
        - subpackage_scenarios
      parameters:
        - name: scenario_name
          in: query
          description: The scenario name. The length must be less than 30
          required: true
          schema:
            type: string
        - name: scenario_script
          in: query
          description: >-
            The scenario text. Use the application/x-www-form-urlencoded content
            type with UTF-8 encoding. The length must be less than 128 KB
          required: false
          schema:
            type: string
        - name: rule_id
          in: query
          description: >-
            The rule ID. The new scenario binds to the specified rule. Please
            note, if you do not bind the scenario to any rule, you cannot
            execute the scenario
          required: false
          schema:
            type: integer
        - name: rule_name
          in: query
          description: The rule name that can be used instead of **rule_id**
          required: false
          schema:
            type: string
        - name: rewrite
          in: query
          description: Whether to rewrite the existing scenario
          required: false
          schema:
            type: boolean
            default: false
        - name: application_id
          in: query
          description: Application ID to bind the scenario to
          required: false
          schema:
            type: integer
        - name: application_name
          in: query
          description: Application name to bind the scenario to
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/scenarios_AddScenario_Response_200'
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    scenarios_AddScenario_Response_200:
      type: object
      properties:
        result:
          type: integer
          description: Returns 1 if the request has been completed successfully
        scenario_id:
          type: integer
          description: The new scenario ID
      title: scenarios_AddScenario_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Example 1
import requests

url = "https://api.voximplant.com/platform_api/AddScenario"

querystring = {"scenario_name":"WelcomeGreeting","scenario_script":"var s='hello';","rule_id":"12345","rewrite":"true"}

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 1
const url = 'https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 1
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Example 1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Example 1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example 1
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example 1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/AddScenario?scenario_name=WelcomeGreeting&scenario_script=var+s%3D%27hello%27%3B&rule_id=12345&rewrite=true")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```